#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include "altera_dma_regs.h"

extern "C" int  ecs_open(int dev, int bar);
extern "C" void ecs_close(int dev, int bar);
extern "C" int pcie40_b2dmabufferreset(int fd);
extern "C" int pcie40_b2dmapointerread(int fd , unsigned int ** pData );

int main (int argc ,char** argv) {
  int res = ecs_open( 0 , 0 ) ;
  if ( -1 == res ) printf("ERROR: Could not open device (BAR 0)\n") ;
  else printf("SUCCESS: Device opened for DMA\n");
  res = ecs_open( 0 , 2 ) ; 
  if ( -1 == res ) printf("ERROR: Could not open device (BAR 2)\n") ;
  else printf("SUCCESS: Device opened for ECS\n");
  // Read DMA
  res = pcie40_b2dmabufferreset( 0 ) ;
  //  unsigned int data[ DMASIZE ] = { 0 } ; 
  unsigned int * data;
  int cnt = 0;
  while( 1 ){
    printf("Reading... %d\n", cnt );
  res = pcie40_b2dmapointerread( 0 , &data ) ;

  int i = 0 ;
  if ( res == 0 ) printf( "DMA Error\n" ) ;
  else {
    printf("00000000  " );
    for (i= 0 ;i < DMASIZE;i++){
      printf("%08x ",data[i]);
      if( ( i % 8 ) == 7 ){
	printf("\n");
	printf("%.8x  ", i + 1);
      }
    }
  }
  usleep(500000);
  cnt++;
  }

  // 
  ecs_close( 0 , 0 ) ;
  ecs_close( 0 , 2 ) ;
  return 0 ;
}
