// File for Belle 2 DMA functions for PCIe40
#include "pcie40_b2dma.h"
#include "pcie40_ecs.h"
#include <stdio.h>

// **************************************************************************
// Reset the address of the DMA buffer
// **************************************************************************
int pcie40_b2dmabufferreset(int fd) { 
  int ret = 0 ;
  ret = ecs_write( fd , DMA_BAR , DMA_BUFFER_RESET_ADD ,
		   1 << DMA_BUFFER_RESET_BIT ) ;
  ret = ecs_write( fd , DMA_BAR , DMA_BUFFER_RESET_ADD ,
		   0 ) ;
  return 0 ;
}

// **************************************************************************
// Resynchronize the b2link, returns 1 if success, 0 if error 
// **************************************************************************
int pcie40_b2dmabufferread(int fd , unsigned int result[] ) { 
  int i ;
  int ret = 0 ;
  unsigned int * pData = 0 ;
  ret = dma_launch( fd , &pData ) ;
  if ( ( pData == NULL ) || ( ret <= 0 ) ) return 0 ;
  for ( i = 0 ; i < DMASIZE ; ++i ) result[ i ] = pData[ i ] ;
  return 1 ;
}

// **************************************************************************
// Resynchronize the b2link, returns 1 if success, 0 if error 
// **************************************************************************
int pcie40_b2dmapointerread(int fd , unsigned int ** pData ) { 
  int i ;
  int ret = 0 ;
  ret = dma_launch( fd , pData ) ;
  if ( ( *pData == NULL ) || ( ret <= 0 ) ) return 0 ;
  return 1 ;
}

