import argparse
from ctypes import *
import random, time

lli = CDLL("libpcie40.so")
slc_read = lli.pcie40_readfee32
slc_read.restype = c_ulong

parser = argparse.ArgumentParser( description = 'Test slow control: read/write random values in register 0x17' )
parser.add_argument('N',type=int,help='Number of events')
parser.add_argument('--channel', '-c' , help = 'Channel number' , type = int , default = 0 )

args = parser.parse_args()
result = 0 
lli.ecs_open( 0 , 2 )

random.seed()

nerr = 0 

for i in xrange( args.N ):
    data = random.randint( 0 , 0xFFFFFFFF )
    lli.pcie40_writefee32( 0 , args.channel , 0x12 , data )
    result = slc_read( 0 , args.channel , 0x12 )
    if result != data:
        print("mismatch between write ({0:X}) and read ({1:X})".format( data , result ))  
        nerr = nerr + 1

lli.ecs_close( 0 , 2 )

print 'Total number of errors = ' + str(nerr)
